#ifndef _ENTITY_H
#define _ENTITY_H

#include "stdinclude.h"
#include <d3dx9.h>

namespace MyEngine
{
	class Model;

	class Entity
	{
	public:
		Entity();

		void SetModel(Model* model) { m_model = model; }

		void SetPosition(const D3DXVECTOR3& pos) { m_pos = pos; }
		D3DXVECTOR3 Position() const { return m_pos; }

		void SetVelocity(const D3DXVECTOR3& vel) { m_vel = vel; }
		D3DXVECTOR3 Velocity() const { return m_vel; }

		void SetAcceleration(const D3DXVECTOR3& accel) { m_accel = accel; }
		D3DXVECTOR3 Acceleration() const { return m_accel; }

		void SetAngle(const D3DXVECTOR3& ang);
		D3DXVECTOR3 Angle() const { return m_ang; }

		void SetAngVelocity(const D3DXVECTOR3& angVel) { m_angVel = angVel; }
		D3DXVECTOR3 AngVelocity() const { return m_angVel; }

		void SetAngAcceleration(const D3DXVECTOR3& angAccel) { m_angAccel = angAccel; }
		D3DXVECTOR3 AngAcceleration() const { return m_angAccel; }

		void OrientationAxes(D3DXVECTOR3& xAxis, D3DXVECTOR3& yAxis, D3DXVECTOR3& zAxis);

		void SetRenderable(bool bRenderable) { m_bRenderable = bRenderable; }

		void Update(float dt);
		void Render();

	protected:
		Model* m_model;

		D3DXVECTOR3 m_pos, m_vel, m_accel;
		D3DXVECTOR3 m_ang, m_angVel, m_angAccel;

		D3DXVECTOR3 m_orientAxes[3];

		bool m_bRenderable;
	};
}

#endif // _ENTITY_H
