#ifndef _SCENEMANAGER_H
#define _SCENEMANAGER_H

#include "stdinclude.h"
#include <d3dx9.h>

namespace MyEngine
{
	class Camera;
	class Entity;

	class SceneManager
	{
	public:
		SceneManager(LPDIRECT3DDEVICE9 pDevice);
		~SceneManager();

		void AddEntity(Entity* pEnt)
		{
			assert(pEnt != NULL);
			m_dynamicObjects.push_back(pEnt);
		}

		void SetCamera(Camera* pCam)
		{
			assert(pCam != NULL);
			m_pCamera = pCam;
		}

		void SetPlayer(Entity* pEnt)
		{
			assert(pEnt != NULL);
			m_pPlayer = pEnt;
		}

		void SetSkyBox(Entity* pEnt)
		{
			assert(pEnt != NULL);
			m_pSkybox = pEnt;
		}

		Camera* GetCamera() const { return m_pCamera; }
		Entity* Player() const { return m_pPlayer; }
		Entity* SkyBox() const { return m_pSkybox; }

		void UpdateScene(uint ms);
		void RenderScene();

	private:
		LPDIRECT3DDEVICE9 m_pDevice;

		Camera* m_pCamera;
		Entity* m_pPlayer;
		Entity* m_pSkybox;

		EntityList m_staticObjects, m_dynamicObjects;
	};
}

#endif // _SCENEMANAGER_H
