#ifndef _STDINCLUDE_H
#define _STDINCLUDE_H

#include <cassert>
#include <string>
#include <vector>
#include <list>
#include <map>
#include <sstream>
#include <fstream>
#include <unknwn.h>
#include <tchar.h>

namespace MyEngine
{
	typedef unsigned int uint;

	typedef std::basic_string<TCHAR> TString;
	typedef std::basic_ostringstream<TCHAR> TOStringStream;
	typedef std::basic_ofstream<TCHAR> TOFileStream;

	void SAFE_RELEASE(IUnknown* p);

	class Model;
	class Entity;
	typedef std::list<Entity*> EntityList;
	typedef std::map<TString, Model*> ModelMap;
}

#endif // _STDINCLUDE_H
